﻿$(document).ready(function () {
    $("#btnSubmitFreshDesk").click(function () {

        create_freshdesk_ticket();
    });
    $(document).on("click", "#btnPostNote", function (e) { create_freshdesk_note(); e.preventDefault(); });
    $(document).on("click", "#post-a-reply", function (e) {
        $("#ticket-reply-block").show();
        $("#ticket-actions").hide();
        $("#ticket-reply-block textarea").focus();
        e.preventDefault();
    });
});
//http://stackoverflow.com/questions/610406/javascript-equivalent-to-printf-string-format/4673436#4673436
if (!String.format) {
    String.format = function (format) {
        var args = Array.prototype.slice.call(arguments, 1);
        return format.replace(/{(\d+)}/g, function (match, number) {
            return typeof args[number] != 'undefined'
              ? args[number]
              : match
            ;
        });
    };
}


function create_freshdesk_note() {
    $("#btnPostNote").before("<span class='text-loader'><span class='roasted-loader'></span></span>");
    $("#btnPostNote").hide();
    $("#btnCancel").hide();
    $.ajax({
        data: $("#form-post-note").serialize(),
        url: $("#form-post-note").attr("action"),
        type: 'POST',
        error: function () {
            $(".text-loader").remove();
            $("#btnPostNote").show();
            $("#btnCancel").show();
            alert(roastedLocalized.AjaxError);
        },
        success: function (data) {
            if (data.error) {
                $(".text-loader").remove();
                $("#btnPostNote").show();
                $("#btnCancel").show();
                if (data.required_field) {
                    alert(String.format(roastedLocalized.AlertRequiredField,data.required_field ));
                }
            }
            else {
                $("#cs-response").html(data);

            }

        }
    });
}
function create_freshdesk_ticket() {
    $("#btnSubmitFreshDesk").before("<span class='text-loader'><span class='roasted-loader'></span></span>");
    $("#btnSubmitFreshDesk").hide();
    $("#btnCancel").hide();
    $.ajax({
        data: $("#ticket-create-form-freshdesk").serialize(),
        url: $("#ticket-create-form-freshdesk").attr("action"),
        type: 'POST',
        error: function () {
            $("#btnSubmitFreshDesk").show();
            $("#btnCancel").show();
            $(".text-loader").remove();
            alert(roastedLocalized.AjaxError);
        },
        success: function (data) {
            if (data.success) {
                $("#freshdesk-form").html("<div class='infobox green'>" + roastedLocalized.SuccessMessage + "<a href='/customer/tickets''>" + roastedLocalized.ShowMyTickets + "</a></div>");
                $(document).scrollTop(0);
            }
            else {
                $("#btnSubmitFreshDesk").show();
                $("#btnCancel").show();
                $(".text-loader").remove();
                if (data.error) {
                    if (data.required_field) {
                        alert(String.format(roastedLocalized.AlertRequiredField, data.required_field));
                    }
                    else if (data.number_field) {
                        alert(String.format(roastedLocalized.AlertNumberField, data.number_field));
                    }
                    else if (data.decimal_field) {
                        alert(String.format(roastedLocalized.AlertDecimalField, data.decimal_field));
                    }
                }
            }
        }
    });
}

